//################################################################################
//# Sample program demonstratng the use of the HugePointer and HugeArray classes #
//################################################################################
// Author: Paul Andre LeBlanc   CIS 71043,1643

#include <stdio.h>
#include "hugeclass.h"

class Foo
{
  public:
    LONG l;
    BYTE b;
    BOOL operator !=(Foo &f) { return l != f.l || b != f.b; }
};

#define ASIZE 100000L

int main(void)
{
  HugeArray<Foo, ASIZE> a;
  HugePointer<Foo> b = a;
  Foo c;
  long x;
  printf("initializing array...");
  for (x = 0; x < ASIZE; x++)
  {
    b->l = x;
    b->b = LOBYTE(LOWORD(x));
    ++b;
  }
  printf("\nverifying array...");
  x = 0;
  b;
  for (x = 0; x < ASIZE; x++)
  {
    if (a[ASIZE - x - 1] != (c = b[-x - 1]))
    {
      printf("\nerror - array[%ld] = %ld, %d", ASIZE - x - 1, c.l, c.b);
      return 1;
    }
  }
  printf("\nHoly smokes! It worked!");
  return 0;
}
